"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var printer_1 = require("graphql/language/printer");
var parser_1 = require("graphql/language/parser");
var validate_1 = require("graphql/validation/validate");
var path_1 = require("path");
var graphql_1 = require("graphql");
var pify = require("pify");
var loaderUtils = require("loader-utils");
function readFile(loader, filePath) {
    return __awaiter(this, void 0, void 0, function () {
        var fsReadFile, content;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fsReadFile = pify(loader.fs.readFile.bind(loader.fs));
                    return [4 /*yield*/, fsReadFile(filePath)];
                case 1:
                    content = _a.sent();
                    return [2 /*return*/, content.toString()];
            }
        });
    });
}
function extractImports(loader, source, document) {
    return __awaiter(this, void 0, void 0, function () {
        var lines, loaderResolve, imports, files, contents, nodes, fragmentDefinitions;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    lines = source.split(/(\r\n|\r|\n)/);
                    loaderResolve = pify(loader.resolve);
                    imports = [];
                    lines.forEach(function (line) {
                        // Find lines that match syntax with `#import "<file>"`
                        if (line[0] !== "#") {
                            return;
                        }
                        var comment = line.slice(1).split(" ");
                        if (comment[0] !== "import") {
                            return;
                        }
                        var filePathMatch = comment[1] && comment[1].match(/^[\"\'](.+)[\"\']/);
                        if (!filePathMatch || !filePathMatch.length) {
                            throw new Error("#import statement must specify a quoted file path");
                        }
                        var filePath = filePathMatch[1];
                        imports.push(new Promise(function (resolve, reject) {
                            loader.resolve(loader.context, filePath, function (err, result) {
                                if (err) {
                                    reject(err);
                                }
                                else {
                                    loader.addDependency(result);
                                    resolve(result);
                                }
                            });
                        }));
                    });
                    return [4 /*yield*/, Promise.all(imports)];
                case 1:
                    files = _a.sent();
                    return [4 /*yield*/, Promise.all(files.map(function (doc) { return readFile(loader, doc); }))];
                case 2:
                    contents = _a.sent();
                    return [4 /*yield*/, Promise.all(contents.map(function (content) { return loadSource(loader, content); }))];
                case 3:
                    nodes = _a.sent();
                    fragmentDefinitions = nodes.reduce(function (defs, node) {
                        defs.push.apply(defs, node.definitions);
                        return defs;
                    }, []);
                    document.definitions = document.definitions.concat(fragmentDefinitions);
                    return [2 /*return*/, document];
            }
        });
    });
}
function loadSource(loader, source) {
    return __awaiter(this, void 0, void 0, function () {
        var document;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    document = parser_1.parse(source);
                    return [4 /*yield*/, extractImports(loader, source, document)];
                case 1:
                    document = _a.sent();
                    return [2 /*return*/, document];
            }
        });
    });
}
function removeDuplicateFragments(document) {
    var usedName = new Set();
    document.definitions = document.definitions.filter(function (def) {
        if (def.kind !== "FragmentDefinition") {
            return true;
        }
        var name = def.name.value;
        if (usedName.has(name)) {
            return false;
        }
        else {
            usedName.add(name);
            return true;
        }
    });
}
function removeSourceLocations(document) {
    if (document.loc) {
        delete document.loc;
    }
    for (var _i = 0, _a = Object.keys(document); _i < _a.length; _i++) {
        var key = _a[_i];
        var value = document[key];
        if (Array.isArray(value)) {
            value.forEach(function (val) { return removeSourceLocations(val); });
        }
        else if (value && typeof value === "object") {
            removeSourceLocations(value);
        }
    }
}
function removeUnusedFragments(document) {
    var usedFragments = new Set();
    function findFragmentSpreads(doc) {
        function traverse(selectionSet) {
            selectionSet.selections.forEach(function (selection) {
                if (selection.kind === "FragmentSpread") {
                    usedFragments.add(selection.name.value);
                }
                else if (selection.selectionSet) {
                    traverse(selection.selectionSet);
                }
            });
        }
        doc.definitions.forEach(function (def) {
            if (def.kind === "OperationDefinition" ||
                def.kind === "FragmentDefinition") {
                traverse(def.selectionSet);
            }
        });
    }
    findFragmentSpreads(document);
    var defCount = document.definitions.length;
    document.definitions = document.definitions.filter(function (def) {
        return def.kind !== "FragmentDefinition" || usedFragments.has(def.name.value);
    });
    if (defCount !== document.definitions.length) {
        // Some references may have been from fragments that were just recently unused.
        // If we removed any fragments, run the function again until we are no longer
        // removing any fragments.
        removeUnusedFragments(document);
    }
}
function loadOptions(loader) {
    return __awaiter(this, void 0, void 0, function () {
        var options, schema, loaderResolve, schemaPath, schemaString;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    options = __assign({}, loaderUtils.getOptions(loader));
                    schema = undefined;
                    if (!options.validate) return [3 /*break*/, 3];
                    if (!options.schema) {
                        throw new Error("schema option must be passed if validate is true");
                    }
                    loaderResolve = pify(loader.resolve);
                    return [4 /*yield*/, findSchemaFile(loader, loader.context, options.schema)];
                case 1:
                    schemaPath = _a.sent();
                    loader.addDependency(schemaPath);
                    return [4 /*yield*/, readFile(loader, schemaPath)];
                case 2:
                    schemaString = _a.sent();
                    schema = graphql_1.buildClientSchema(JSON.parse(schemaString));
                    _a.label = 3;
                case 3: return [2 /*return*/, {
                        schema: schema,
                        output: !options.output || options.output === "string"
                            ? "string"
                            : "document",
                        removeUnusedFragments: options.removeUnusedFragments
                    }];
            }
        });
    });
}
function findSchemaFile(loader, context, schemaPath) {
    return __awaiter(this, void 0, void 0, function () {
        var fsStat, currentContext, fileName, err_1, parent;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fsStat = pify(loader.fs.stat.bind(loader.fs));
                    currentContext = context;
                    _a.label = 1;
                case 1:
                    if (!true) return [3 /*break*/, 6];
                    fileName = path_1.join(currentContext, schemaPath);
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, fsStat(fileName)];
                case 3:
                    if ((_a.sent()).isFile()) {
                        return [2 /*return*/, fileName];
                    }
                    return [3 /*break*/, 5];
                case 4:
                    err_1 = _a.sent();
                    return [3 /*break*/, 5];
                case 5:
                    parent = path_1.dirname(currentContext);
                    if (parent === currentContext) {
                        // Reached root of the fs, but we still haven't found anything.
                        throw new Error("Could not find schema file '" + schemaPath + " from any parent of '" + context + "'");
                    }
                    currentContext = parent;
                    return [3 /*break*/, 1];
                case 6: return [2 /*return*/];
            }
        });
    });
}
function loader(source) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        var done, validationErrors, options, document, output, err_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    this.cacheable();
                    done = this.async();
                    if (!done) {
                        throw new Error("Loader does not support synchronous processing");
                    }
                    validationErrors = [];
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 4, , 5]);
                    return [4 /*yield*/, loadOptions(this)];
                case 2:
                    options = _a.sent();
                    return [4 /*yield*/, loadSource(this, source)];
                case 3:
                    document = _a.sent();
                    removeDuplicateFragments(document);
                    removeSourceLocations(document);
                    if (options.removeUnusedFragments) {
                        removeUnusedFragments(document);
                    }
                    if (options.schema) {
                        // Validate
                        validationErrors = validate_1.validate(options.schema, document);
                        if (validationErrors.length > 0) {
                            validationErrors.forEach(function (err) { return _this.emitError(err); });
                        }
                    }
                    output = JSON.stringify(options.output === "document" ? document : printer_1.print(document));
                    done(null, "module.exports = " + output);
                    return [3 /*break*/, 5];
                case 4:
                    err_2 = _a.sent();
                    done(err_2);
                    return [3 /*break*/, 5];
                case 5: return [2 /*return*/];
            }
        });
    });
}
exports["default"] = loader;
//# sourceMappingURL=loader.js.map